# SwaggerClient-php
Hourly vertically interpolated forecast data from the ECMWF model for latitude/longitude points,OnPoint Ids. Hourly forecast is up to 10 days out from current day. The Weather Source ECMWF Vert Forecast API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.    **IMPORTANT:** To authenticate to the Weather Source ECMWF Vert Forecast API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.0
- Build package: io.swagger.codegen.v3.generators.php.PhpClientCodegen
For more information, please visit [https://developer.weathersourceapis.com/](https://developer.weathersourceapis.com/)

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com/GIT_USER_ID/GIT_REPO_ID.git"
    }
  ],
  "require": {
    "GIT_USER_ID/GIT_REPO_ID": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: ApiKeyAuth
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-API-KEY', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-KEY', 'Bearer');

$apiInstance = new Swagger\Client\Api\OnpointsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$onpoint_id = 56; // int | An OnPoint™ ID.
$fields = array("fields_example"); // string[] | A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*
$height = 1.2; // float | The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type.
$unit_scale = "IMPERIAL"; // string | The unit scale for returned values.<br>

try {
    $result = $apiInstance->onpointsOnpointIdHeightHeightHoursGet($onpoint_id, $fields, $height, $unit_scale);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling OnpointsApi->onpointsOnpointIdHeightHeightHoursGet: ', $e->getMessage(), PHP_EOL;
}

// Configure API key authorization: ApiKeyAuth
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-API-KEY', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-KEY', 'Bearer');

$apiInstance = new Swagger\Client\Api\OnpointsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$onpoint_id = 56; // int | An OnPoint™ ID.
$timestamp = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | A timestamp formatted as an RFC3339 date-time value. The UTC offset is required.
$fields = array("fields_example"); // string[] | A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*
$height = 1.2; // float | The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type.
$unit_scale = "IMPERIAL"; // string | The unit scale for returned values.<br>

try {
    $result = $apiInstance->onpointsOnpointIdHeightHeightHoursTimestampGet($onpoint_id, $timestamp, $fields, $height, $unit_scale);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling OnpointsApi->onpointsOnpointIdHeightHeightHoursTimestampGet: ', $e->getMessage(), PHP_EOL;
}

// Configure API key authorization: ApiKeyAuth
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-API-KEY', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-KEY', 'Bearer');

$apiInstance = new Swagger\Client\Api\OnpointsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$onpoint_id = 56; // int | An OnPoint™ ID.
$timestamp_start = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required.
$timestamp_end = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required.
$fields = array("fields_example"); // string[] | A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*
$height = 1.2; // float | The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type.
$unit_scale = "IMPERIAL"; // string | The unit scale for returned values.<br>

try {
    $result = $apiInstance->onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling OnpointsApi->onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

## Documentation for API Endpoints

All URIs are relative to *https://ecmwfvertforecast.weathersourceapis.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OnpointsApi* | [**onpointsOnpointIdHeightHeightHoursGet**](docs/Api/OnpointsApi.md#onpointsonpointidheightheighthoursget) | **GET** /onpoints/{onpointId}/height/{height}/hours | The complete hourly ECMWF Vert forecast for an OnPoint™ ID.
*OnpointsApi* | [**onpointsOnpointIdHeightHeightHoursTimestampGet**](docs/Api/OnpointsApi.md#onpointsonpointidheightheighthourstimestampget) | **GET** /onpoints/{onpointId}/height/{height}/hours/{timestamp} | An hour of ECMWF Vert forecast data for an OnPoint™ ID.
*OnpointsApi* | [**onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet**](docs/Api/OnpointsApi.md#onpointsonpointidheightheighthourstimestampstarttimestampendget) | **GET** /onpoints/{onpointId}/height/{height}/hours/{timestampStart},{timestampEnd} | A contiguous range of hourly ECMWF Vert forecast data for an OnPoint™ ID.
*PointsApi* | [**pointsLatitudelongitudeHeightHeightHoursGet**](docs/Api/PointsApi.md#pointslatitudelongitudeheightheighthoursget) | **GET** /points/{latitude},{longitude}/height/{height}/hours | The complete hourly ECMWF Vert forecast for a Latitude/Longitude point.
*PointsApi* | [**pointsLatitudelongitudeHeightHeightHoursTimestampGet**](docs/Api/PointsApi.md#pointslatitudelongitudeheightheighthourstimestampget) | **GET** /points/{latitude},{longitude}/height/{height}/hours/{timestamp} | An hour of ECMWF Vert forecast data for a Latitude/Longitude point.
*PointsApi* | [**pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet**](docs/Api/PointsApi.md#pointslatitudelongitudeheightheighthourstimestampstarttimestampendget) | **GET** /points/{latitude},{longitude}/height/{height}/hours/{timestampStart},{timestampEnd} | A contiguous range of hourly ECMWF Vert forecast data for a Latitude/Longitude point.

## Documentation For Models

 - [BoundingPoints](docs/Model/BoundingPoints.md)
 - [BoundingPointsInner](docs/Model/BoundingPointsInner.md)
 - [CldCvr](docs/Model/CldCvr.md)
 - [CountryCode](docs/Model/CountryCode.md)
 - [CountryName](docs/Model/CountryName.md)
 - [DewPt](docs/Model/DewPt.md)
 - [Distance](docs/Model/Distance.md)
 - [EcmwfForecastHourArr](docs/Model/EcmwfForecastHourArr.md)
 - [EcmwfForecastHourObj](docs/Model/EcmwfForecastHourObj.md)
 - [EcmwfForecastOnpointHourObj](docs/Model/EcmwfForecastOnpointHourObj.md)
 - [EcmwfForecastPointHourObj](docs/Model/EcmwfForecastPointHourObj.md)
 - [Elevation](docs/Model/Elevation.md)
 - [ErrorObj](docs/Model/ErrorObj.md)
 - [FeelsLike](docs/Model/FeelsLike.md)
 - [FieldListHourObj](docs/Model/FieldListHourObj.md)
 - [Fields](docs/Model/Fields.md)
 - [Grid](docs/Model/Grid.md)
 - [HeatIndex](docs/Model/HeatIndex.md)
 - [Latitude](docs/Model/Latitude.md)
 - [Longitude](docs/Model/Longitude.md)
 - [MslPres](docs/Model/MslPres.md)
 - [OnpointId](docs/Model/OnpointId.md)
 - [OnpointObj](docs/Model/OnpointObj.md)
 - [PointObj](docs/Model/PointObj.md)
 - [Precip](docs/Model/Precip.md)
 - [PrecipProb](docs/Model/PrecipProb.md)
 - [Pres](docs/Model/Pres.md)
 - [RadSolar](docs/Model/RadSolar.md)
 - [RadSolarDirect](docs/Model/RadSolarDirect.md)
 - [RadSolarDirectP](docs/Model/RadSolarDirectP.md)
 - [RelHum](docs/Model/RelHum.md)
 - [Snowfall](docs/Model/Snowfall.md)
 - [SnowfallProb](docs/Model/SnowfallProb.md)
 - [SpcHum](docs/Model/SpcHum.md)
 - [SubdivCode](docs/Model/SubdivCode.md)
 - [SubdivName](docs/Model/SubdivName.md)
 - [Temp](docs/Model/Temp.md)
 - [Timestamp](docs/Model/Timestamp.md)
 - [TimestampEnd](docs/Model/TimestampEnd.md)
 - [TimestampInit](docs/Model/TimestampInit.md)
 - [TimestampRangeObj](docs/Model/TimestampRangeObj.md)
 - [TimestampStart](docs/Model/TimestampStart.md)
 - [Timezone](docs/Model/Timezone.md)
 - [WetBulb](docs/Model/WetBulb.md)
 - [WindChill](docs/Model/WindChill.md)
 - [WindDir](docs/Model/WindDir.md)
 - [WindSpd](docs/Model/WindSpd.md)

## Documentation For Authorization


## ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-API-KEY
- **Location**: HTTP header


## Author

support@weathersource.com

