# Swagger\Client\PointsApi

All URIs are relative to *https://ecmwfvertforecast.weathersourceapis.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**pointsLatitudelongitudeHeightHeightHoursGet**](PointsApi.md#pointslatitudelongitudeheightheighthoursget) | **GET** /points/{latitude},{longitude}/height/{height}/hours | The complete hourly ECMWF Vert forecast for a Latitude/Longitude point.
[**pointsLatitudelongitudeHeightHeightHoursTimestampGet**](PointsApi.md#pointslatitudelongitudeheightheighthourstimestampget) | **GET** /points/{latitude},{longitude}/height/{height}/hours/{timestamp} | An hour of ECMWF Vert forecast data for a Latitude/Longitude point.
[**pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet**](PointsApi.md#pointslatitudelongitudeheightheighthourstimestampstarttimestampendget) | **GET** /points/{latitude},{longitude}/height/{height}/hours/{timestampStart},{timestampEnd} | A contiguous range of hourly ECMWF Vert forecast data for a Latitude/Longitude point.

# **pointsLatitudelongitudeHeightHeightHoursGet**
> \Swagger\Client\Model\EcmwfForecastPointHourObj pointsLatitudelongitudeHeightHeightHoursGet($latitude, $longitude, $fields, $height, $unit_scale)

The complete hourly ECMWF Vert forecast for a Latitude/Longitude point.

Returns the complete set of ECMWF forecast data for a Latitude/Longitude point.  *Alternatively using a query that specificies just the hours required for your purposes will improve the query response time.*  **IMPORTANT:** To authenticate to the Weather Source ECMWF Vert Forecast API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-API-KEY', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-KEY', 'Bearer');

$apiInstance = new Swagger\Client\Api\PointsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$latitude = 3.4; // float | A latitude value between -90° and 90°.
$longitude = 3.4; // float | A longitude value between -180° (West) and 180° (East).
$fields = array("fields_example"); // string[] | A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*
$height = 1.2; // float | The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type.
$unit_scale = "IMPERIAL"; // string | The unit scale for returned values.<br>

try {
    $result = $apiInstance->pointsLatitudelongitudeHeightHeightHoursGet($latitude, $longitude, $fields, $height, $unit_scale);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PointsApi->pointsLatitudelongitudeHeightHeightHoursGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **latitude** | **float**| A latitude value between -90° and 90°. |
 **longitude** | **float**| A longitude value between -180° (West) and 180° (East). |
 **fields** | [**string[]**](../Model/string.md)| A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* |
 **height** | **float**| The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. |
 **unit_scale** | **string**| The unit scale for returned values.&lt;br&gt; | [optional] [default to IMPERIAL]

### Return type

[**\Swagger\Client\Model\EcmwfForecastPointHourObj**](../Model/EcmwfForecastPointHourObj.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **pointsLatitudelongitudeHeightHeightHoursTimestampGet**
> \Swagger\Client\Model\EcmwfForecastPointHourObj pointsLatitudelongitudeHeightHeightHoursTimestampGet($latitude, $longitude, $timestamp, $fields, $height, $unit_scale)

An hour of ECMWF Vert forecast data for a Latitude/Longitude point.

Returns a single hour of ECMWF Vert forecast data for a Latitude/Longitude point. The provided timestamp must exist within the current valid 10-day forecast range.  **IMPORTANT:** To authenticate to the Weather Source ECMWF Vert Forecast API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-API-KEY', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-KEY', 'Bearer');

$apiInstance = new Swagger\Client\Api\PointsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$latitude = 3.4; // float | A latitude value between -90° and 90°.
$longitude = 3.4; // float | A longitude value between -180° (West) and 180° (East).
$timestamp = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | A timestamp formatted as an RFC3339 date-time value. The UTC offset is required.
$fields = array("fields_example"); // string[] | A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*
$height = 1.2; // float | The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type.
$unit_scale = "IMPERIAL"; // string | The unit scale for returned values.<br>

try {
    $result = $apiInstance->pointsLatitudelongitudeHeightHeightHoursTimestampGet($latitude, $longitude, $timestamp, $fields, $height, $unit_scale);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PointsApi->pointsLatitudelongitudeHeightHeightHoursTimestampGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **latitude** | **float**| A latitude value between -90° and 90°. |
 **longitude** | **float**| A longitude value between -180° (West) and 180° (East). |
 **timestamp** | **\DateTime**| A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. |
 **fields** | [**string[]**](../Model/string.md)| A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* |
 **height** | **float**| The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. |
 **unit_scale** | **string**| The unit scale for returned values.&lt;br&gt; | [optional] [default to IMPERIAL]

### Return type

[**\Swagger\Client\Model\EcmwfForecastPointHourObj**](../Model/EcmwfForecastPointHourObj.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet**
> \Swagger\Client\Model\EcmwfForecastPointHourObj pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale)

A contiguous range of hourly ECMWF Vert forecast data for a Latitude/Longitude point.

Returns a contiguous range of hourly ECMWF Vert forecast data for a Latitude/Longitude point. The provided timestamps must exist within the current valid 10-day forecast range.  **IMPORTANT:** To authenticate to the Weather Source ECMWF Vert Forecast API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-API-KEY', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-API-KEY', 'Bearer');

$apiInstance = new Swagger\Client\Api\PointsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$latitude = 3.4; // float | A latitude value between -90° and 90°.
$longitude = 3.4; // float | A longitude value between -180° (West) and 180° (East).
$timestamp_start = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required.
$timestamp_end = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required.
$fields = array("fields_example"); // string[] | A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*
$height = 1.2; // float | The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type.
$unit_scale = "IMPERIAL"; // string | The unit scale for returned values.<br>

try {
    $result = $apiInstance->pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling PointsApi->pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **latitude** | **float**| A latitude value between -90° and 90°. |
 **longitude** | **float**| A longitude value between -180° (West) and 180° (East). |
 **timestamp_start** | **\DateTime**| A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. |
 **timestamp_end** | **\DateTime**| A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. |
 **fields** | [**string[]**](../Model/string.md)| A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* |
 **height** | **float**| The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. |
 **unit_scale** | **string**| The unit scale for returned values.&lt;br&gt; | [optional] [default to IMPERIAL]

### Return type

[**\Swagger\Client\Model\EcmwfForecastPointHourObj**](../Model/EcmwfForecastPointHourObj.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

