<?php
/**
 * OnpointsApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * ECMWF Vert Forecast - A Weather Source API
 *
 * Hourly vertically interpolated forecast data from the ECMWF model for latitude/longitude points,OnPoint Ids. Hourly forecast is up to 10 days out from current day. The Weather Source ECMWF Vert Forecast API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.    **IMPORTANT:** To authenticate to the Weather Source ECMWF Vert Forecast API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.33
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * OnpointsApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class OnpointsApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursGet
     *
     * The complete hourly ECMWF Vert forecast for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\EcmwfForecastOnpointHourObj
     */
    public function onpointsOnpointIdHeightHeightHoursGet($onpoint_id, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->onpointsOnpointIdHeightHeightHoursGetWithHttpInfo($onpoint_id, $fields, $height, $unit_scale);
        return $response;
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursGetWithHttpInfo
     *
     * The complete hourly ECMWF Vert forecast for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\EcmwfForecastOnpointHourObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function onpointsOnpointIdHeightHeightHoursGetWithHttpInfo($onpoint_id, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastOnpointHourObj';
        $request = $this->onpointsOnpointIdHeightHeightHoursGetRequest($onpoint_id, $fields, $height, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\EcmwfForecastOnpointHourObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursGetAsync
     *
     * The complete hourly ECMWF Vert forecast for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHeightHeightHoursGetAsync($onpoint_id, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        return $this->onpointsOnpointIdHeightHeightHoursGetAsyncWithHttpInfo($onpoint_id, $fields, $height, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursGetAsyncWithHttpInfo
     *
     * The complete hourly ECMWF Vert forecast for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHeightHeightHoursGetAsyncWithHttpInfo($onpoint_id, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastOnpointHourObj';
        $request = $this->onpointsOnpointIdHeightHeightHoursGetRequest($onpoint_id, $fields, $height, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'onpointsOnpointIdHeightHeightHoursGet'
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function onpointsOnpointIdHeightHeightHoursGetRequest($onpoint_id, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'onpoint_id' is set
        if ($onpoint_id === null || (is_array($onpoint_id) && count($onpoint_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $onpoint_id when calling onpointsOnpointIdHeightHeightHoursGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling onpointsOnpointIdHeightHeightHoursGet'
            );
        }
        // verify the required parameter 'height' is set
        if ($height === null || (is_array($height) && count($height) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $height when calling onpointsOnpointIdHeightHeightHoursGet'
            );
        }

        $resourcePath = '/onpoints/{onpointId}/height/{height}/hours';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($onpoint_id !== null) {
            $resourcePath = str_replace(
                '{' . 'onpointId' . '}',
                ObjectSerializer::toPathValue($onpoint_id),
                $resourcePath
            );
        }
        // path params
        if ($height !== null) {
            $resourcePath = str_replace(
                '{' . 'height' . '}',
                ObjectSerializer::toPathValue($height),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursTimestampGet
     *
     * An hour of ECMWF Vert forecast data for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\EcmwfForecastOnpointHourObj
     */
    public function onpointsOnpointIdHeightHeightHoursTimestampGet($onpoint_id, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->onpointsOnpointIdHeightHeightHoursTimestampGetWithHttpInfo($onpoint_id, $timestamp, $fields, $height, $unit_scale);
        return $response;
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursTimestampGetWithHttpInfo
     *
     * An hour of ECMWF Vert forecast data for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\EcmwfForecastOnpointHourObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function onpointsOnpointIdHeightHeightHoursTimestampGetWithHttpInfo($onpoint_id, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastOnpointHourObj';
        $request = $this->onpointsOnpointIdHeightHeightHoursTimestampGetRequest($onpoint_id, $timestamp, $fields, $height, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\EcmwfForecastOnpointHourObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursTimestampGetAsync
     *
     * An hour of ECMWF Vert forecast data for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHeightHeightHoursTimestampGetAsync($onpoint_id, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        return $this->onpointsOnpointIdHeightHeightHoursTimestampGetAsyncWithHttpInfo($onpoint_id, $timestamp, $fields, $height, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursTimestampGetAsyncWithHttpInfo
     *
     * An hour of ECMWF Vert forecast data for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHeightHeightHoursTimestampGetAsyncWithHttpInfo($onpoint_id, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastOnpointHourObj';
        $request = $this->onpointsOnpointIdHeightHeightHoursTimestampGetRequest($onpoint_id, $timestamp, $fields, $height, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'onpointsOnpointIdHeightHeightHoursTimestampGet'
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function onpointsOnpointIdHeightHeightHoursTimestampGetRequest($onpoint_id, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'onpoint_id' is set
        if ($onpoint_id === null || (is_array($onpoint_id) && count($onpoint_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $onpoint_id when calling onpointsOnpointIdHeightHeightHoursTimestampGet'
            );
        }
        // verify the required parameter 'timestamp' is set
        if ($timestamp === null || (is_array($timestamp) && count($timestamp) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $timestamp when calling onpointsOnpointIdHeightHeightHoursTimestampGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling onpointsOnpointIdHeightHeightHoursTimestampGet'
            );
        }
        // verify the required parameter 'height' is set
        if ($height === null || (is_array($height) && count($height) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $height when calling onpointsOnpointIdHeightHeightHoursTimestampGet'
            );
        }

        $resourcePath = '/onpoints/{onpointId}/height/{height}/hours/{timestamp}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($onpoint_id !== null) {
            $resourcePath = str_replace(
                '{' . 'onpointId' . '}',
                ObjectSerializer::toPathValue($onpoint_id),
                $resourcePath
            );
        }
        // path params
        if ($timestamp !== null) {
            $resourcePath = str_replace(
                '{' . 'timestamp' . '}',
                ObjectSerializer::toPathValue($timestamp),
                $resourcePath
            );
        }
        // path params
        if ($height !== null) {
            $resourcePath = str_replace(
                '{' . 'height' . '}',
                ObjectSerializer::toPathValue($height),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet
     *
     * A contiguous range of hourly ECMWF Vert forecast data for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\EcmwfForecastOnpointHourObj
     */
    public function onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetWithHttpInfo($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale);
        return $response;
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetWithHttpInfo
     *
     * A contiguous range of hourly ECMWF Vert forecast data for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\EcmwfForecastOnpointHourObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetWithHttpInfo($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastOnpointHourObj';
        $request = $this->onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetRequest($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\EcmwfForecastOnpointHourObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetAsync
     *
     * A contiguous range of hourly ECMWF Vert forecast data for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetAsync($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        return $this->onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetAsyncWithHttpInfo($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetAsyncWithHttpInfo
     *
     * A contiguous range of hourly ECMWF Vert forecast data for an OnPoint™ ID.
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetAsyncWithHttpInfo($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastOnpointHourObj';
        $request = $this->onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetRequest($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet'
     *
     * @param  int $onpoint_id An OnPoint™ ID. (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGetRequest($onpoint_id, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'onpoint_id' is set
        if ($onpoint_id === null || (is_array($onpoint_id) && count($onpoint_id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $onpoint_id when calling onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'timestamp_start' is set
        if ($timestamp_start === null || (is_array($timestamp_start) && count($timestamp_start) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $timestamp_start when calling onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'timestamp_end' is set
        if ($timestamp_end === null || (is_array($timestamp_end) && count($timestamp_end) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $timestamp_end when calling onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'height' is set
        if ($height === null || (is_array($height) && count($height) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $height when calling onpointsOnpointIdHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }

        $resourcePath = '/onpoints/{onpointId}/height/{height}/hours/{timestampStart},{timestampEnd}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($onpoint_id !== null) {
            $resourcePath = str_replace(
                '{' . 'onpointId' . '}',
                ObjectSerializer::toPathValue($onpoint_id),
                $resourcePath
            );
        }
        // path params
        if ($timestamp_start !== null) {
            $resourcePath = str_replace(
                '{' . 'timestampStart' . '}',
                ObjectSerializer::toPathValue($timestamp_start),
                $resourcePath
            );
        }
        // path params
        if ($timestamp_end !== null) {
            $resourcePath = str_replace(
                '{' . 'timestampEnd' . '}',
                ObjectSerializer::toPathValue($timestamp_end),
                $resourcePath
            );
        }
        // path params
        if ($height !== null) {
            $resourcePath = str_replace(
                '{' . 'height' . '}',
                ObjectSerializer::toPathValue($height),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
