<?php
/**
 * PointsApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * ECMWF Vert Forecast - A Weather Source API
 *
 * Hourly vertically interpolated forecast data from the ECMWF model for latitude/longitude points,OnPoint Ids. Hourly forecast is up to 10 days out from current day. The Weather Source ECMWF Vert Forecast API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.    **IMPORTANT:** To authenticate to the Weather Source ECMWF Vert Forecast API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.33
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Swagger\Client\ApiException;
use Swagger\Client\Configuration;
use Swagger\Client\HeaderSelector;
use Swagger\Client\ObjectSerializer;

/**
 * PointsApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PointsApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursGet
     *
     * The complete hourly ECMWF Vert forecast for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\EcmwfForecastPointHourObj
     */
    public function pointsLatitudelongitudeHeightHeightHoursGet($latitude, $longitude, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->pointsLatitudelongitudeHeightHeightHoursGetWithHttpInfo($latitude, $longitude, $fields, $height, $unit_scale);
        return $response;
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursGetWithHttpInfo
     *
     * The complete hourly ECMWF Vert forecast for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\EcmwfForecastPointHourObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function pointsLatitudelongitudeHeightHeightHoursGetWithHttpInfo($latitude, $longitude, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastPointHourObj';
        $request = $this->pointsLatitudelongitudeHeightHeightHoursGetRequest($latitude, $longitude, $fields, $height, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\EcmwfForecastPointHourObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursGetAsync
     *
     * The complete hourly ECMWF Vert forecast for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pointsLatitudelongitudeHeightHeightHoursGetAsync($latitude, $longitude, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        return $this->pointsLatitudelongitudeHeightHeightHoursGetAsyncWithHttpInfo($latitude, $longitude, $fields, $height, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursGetAsyncWithHttpInfo
     *
     * The complete hourly ECMWF Vert forecast for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pointsLatitudelongitudeHeightHeightHoursGetAsyncWithHttpInfo($latitude, $longitude, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastPointHourObj';
        $request = $this->pointsLatitudelongitudeHeightHeightHoursGetRequest($latitude, $longitude, $fields, $height, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'pointsLatitudelongitudeHeightHeightHoursGet'
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function pointsLatitudelongitudeHeightHeightHoursGetRequest($latitude, $longitude, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'latitude' is set
        if ($latitude === null || (is_array($latitude) && count($latitude) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $latitude when calling pointsLatitudelongitudeHeightHeightHoursGet'
            );
        }
        // verify the required parameter 'longitude' is set
        if ($longitude === null || (is_array($longitude) && count($longitude) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $longitude when calling pointsLatitudelongitudeHeightHeightHoursGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling pointsLatitudelongitudeHeightHeightHoursGet'
            );
        }
        // verify the required parameter 'height' is set
        if ($height === null || (is_array($height) && count($height) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $height when calling pointsLatitudelongitudeHeightHeightHoursGet'
            );
        }

        $resourcePath = '/points/{latitude},{longitude}/height/{height}/hours';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($latitude !== null) {
            $resourcePath = str_replace(
                '{' . 'latitude' . '}',
                ObjectSerializer::toPathValue($latitude),
                $resourcePath
            );
        }
        // path params
        if ($longitude !== null) {
            $resourcePath = str_replace(
                '{' . 'longitude' . '}',
                ObjectSerializer::toPathValue($longitude),
                $resourcePath
            );
        }
        // path params
        if ($height !== null) {
            $resourcePath = str_replace(
                '{' . 'height' . '}',
                ObjectSerializer::toPathValue($height),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursTimestampGet
     *
     * An hour of ECMWF Vert forecast data for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\EcmwfForecastPointHourObj
     */
    public function pointsLatitudelongitudeHeightHeightHoursTimestampGet($latitude, $longitude, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->pointsLatitudelongitudeHeightHeightHoursTimestampGetWithHttpInfo($latitude, $longitude, $timestamp, $fields, $height, $unit_scale);
        return $response;
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursTimestampGetWithHttpInfo
     *
     * An hour of ECMWF Vert forecast data for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\EcmwfForecastPointHourObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function pointsLatitudelongitudeHeightHeightHoursTimestampGetWithHttpInfo($latitude, $longitude, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastPointHourObj';
        $request = $this->pointsLatitudelongitudeHeightHeightHoursTimestampGetRequest($latitude, $longitude, $timestamp, $fields, $height, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\EcmwfForecastPointHourObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursTimestampGetAsync
     *
     * An hour of ECMWF Vert forecast data for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pointsLatitudelongitudeHeightHeightHoursTimestampGetAsync($latitude, $longitude, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        return $this->pointsLatitudelongitudeHeightHeightHoursTimestampGetAsyncWithHttpInfo($latitude, $longitude, $timestamp, $fields, $height, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursTimestampGetAsyncWithHttpInfo
     *
     * An hour of ECMWF Vert forecast data for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pointsLatitudelongitudeHeightHeightHoursTimestampGetAsyncWithHttpInfo($latitude, $longitude, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastPointHourObj';
        $request = $this->pointsLatitudelongitudeHeightHeightHoursTimestampGetRequest($latitude, $longitude, $timestamp, $fields, $height, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'pointsLatitudelongitudeHeightHeightHoursTimestampGet'
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function pointsLatitudelongitudeHeightHeightHoursTimestampGetRequest($latitude, $longitude, $timestamp, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'latitude' is set
        if ($latitude === null || (is_array($latitude) && count($latitude) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $latitude when calling pointsLatitudelongitudeHeightHeightHoursTimestampGet'
            );
        }
        // verify the required parameter 'longitude' is set
        if ($longitude === null || (is_array($longitude) && count($longitude) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $longitude when calling pointsLatitudelongitudeHeightHeightHoursTimestampGet'
            );
        }
        // verify the required parameter 'timestamp' is set
        if ($timestamp === null || (is_array($timestamp) && count($timestamp) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $timestamp when calling pointsLatitudelongitudeHeightHeightHoursTimestampGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling pointsLatitudelongitudeHeightHeightHoursTimestampGet'
            );
        }
        // verify the required parameter 'height' is set
        if ($height === null || (is_array($height) && count($height) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $height when calling pointsLatitudelongitudeHeightHeightHoursTimestampGet'
            );
        }

        $resourcePath = '/points/{latitude},{longitude}/height/{height}/hours/{timestamp}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($latitude !== null) {
            $resourcePath = str_replace(
                '{' . 'latitude' . '}',
                ObjectSerializer::toPathValue($latitude),
                $resourcePath
            );
        }
        // path params
        if ($longitude !== null) {
            $resourcePath = str_replace(
                '{' . 'longitude' . '}',
                ObjectSerializer::toPathValue($longitude),
                $resourcePath
            );
        }
        // path params
        if ($timestamp !== null) {
            $resourcePath = str_replace(
                '{' . 'timestamp' . '}',
                ObjectSerializer::toPathValue($timestamp),
                $resourcePath
            );
        }
        // path params
        if ($height !== null) {
            $resourcePath = str_replace(
                '{' . 'height' . '}',
                ObjectSerializer::toPathValue($height),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet
     *
     * A contiguous range of hourly ECMWF Vert forecast data for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Swagger\Client\Model\EcmwfForecastPointHourObj
     */
    public function pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        list($response) = $this->pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetWithHttpInfo($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale);
        return $response;
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetWithHttpInfo
     *
     * A contiguous range of hourly ECMWF Vert forecast data for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Swagger\Client\Model\EcmwfForecastPointHourObj, HTTP status code, HTTP response headers (array of strings)
     */
    public function pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetWithHttpInfo($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastPointHourObj';
        $request = $this->pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetRequest($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if (!in_array($returnType, ['string','integer','bool'])) {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\EcmwfForecastPointHourObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Swagger\Client\Model\ErrorObj',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetAsync
     *
     * A contiguous range of hourly ECMWF Vert forecast data for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetAsync($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        return $this->pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetAsyncWithHttpInfo($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetAsyncWithHttpInfo
     *
     * A contiguous range of hourly ECMWF Vert forecast data for a Latitude/Longitude point.
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetAsyncWithHttpInfo($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        $returnType = '\Swagger\Client\Model\EcmwfForecastPointHourObj';
        $request = $this->pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetRequest($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = $responseBody->getContents();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet'
     *
     * @param  float $latitude A latitude value between -90° and 90°. (required)
     * @param  float $longitude A longitude value between -180° (West) and 180° (East). (required)
     * @param  \DateTime $timestamp_start A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. (required)
     * @param  \DateTime $timestamp_end A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. (required)
     * @param  string[] $fields A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, pres)* * allRad *(radSolar, radSolarDirect, radSolarDirectP)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windSpd)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)* (required)
     * @param  float $height The height in meters at which to vertically interpolate. The height MUST be in meters, even if selecting IMPERIAL unit type. (required)
     * @param  string $unit_scale The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGetRequest($latitude, $longitude, $timestamp_start, $timestamp_end, $fields, $height, $unit_scale = 'IMPERIAL')
    {
        // verify the required parameter 'latitude' is set
        if ($latitude === null || (is_array($latitude) && count($latitude) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $latitude when calling pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'longitude' is set
        if ($longitude === null || (is_array($longitude) && count($longitude) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $longitude when calling pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'timestamp_start' is set
        if ($timestamp_start === null || (is_array($timestamp_start) && count($timestamp_start) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $timestamp_start when calling pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'timestamp_end' is set
        if ($timestamp_end === null || (is_array($timestamp_end) && count($timestamp_end) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $timestamp_end when calling pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'fields' is set
        if ($fields === null || (is_array($fields) && count($fields) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $fields when calling pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }
        // verify the required parameter 'height' is set
        if ($height === null || (is_array($height) && count($height) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $height when calling pointsLatitudelongitudeHeightHeightHoursTimestampStarttimestampEndGet'
            );
        }

        $resourcePath = '/points/{latitude},{longitude}/height/{height}/hours/{timestampStart},{timestampEnd}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($fields)) {
            $fields = ObjectSerializer::serializeCollection($fields, 'csv', true);
        }
        if ($fields !== null) {
            $queryParams['fields'] = ObjectSerializer::toQueryValue($fields, null);
        }
        // query params
        if ($unit_scale !== null) {
            $queryParams['unitScale'] = ObjectSerializer::toQueryValue($unit_scale, null);
        }

        // path params
        if ($latitude !== null) {
            $resourcePath = str_replace(
                '{' . 'latitude' . '}',
                ObjectSerializer::toPathValue($latitude),
                $resourcePath
            );
        }
        // path params
        if ($longitude !== null) {
            $resourcePath = str_replace(
                '{' . 'longitude' . '}',
                ObjectSerializer::toPathValue($longitude),
                $resourcePath
            );
        }
        // path params
        if ($timestamp_start !== null) {
            $resourcePath = str_replace(
                '{' . 'timestampStart' . '}',
                ObjectSerializer::toPathValue($timestamp_start),
                $resourcePath
            );
        }
        // path params
        if ($timestamp_end !== null) {
            $resourcePath = str_replace(
                '{' . 'timestampEnd' . '}',
                ObjectSerializer::toPathValue($timestamp_end),
                $resourcePath
            );
        }
        // path params
        if ($height !== null) {
            $resourcePath = str_replace(
                '{' . 'height' . '}',
                ObjectSerializer::toPathValue($height),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }

        // this endpoint requires API key authentication
        $apiKey = $this->config->getApiKeyWithPrefix('X-API-KEY');
        if ($apiKey !== null) {
            $headers['X-API-KEY'] = $apiKey;
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
