<?php
/**
 * EcmwfForecastHourObj
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * ECMWF Vert Forecast - A Weather Source API
 *
 * Hourly vertically interpolated forecast data from the ECMWF model for latitude/longitude points,OnPoint Ids. Hourly forecast is up to 10 days out from current day. The Weather Source ECMWF Vert Forecast API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.    **IMPORTANT:** To authenticate to the Weather Source ECMWF Vert Forecast API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page.
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.33
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * EcmwfForecastHourObj Class Doc Comment
 *
 * @category Class
 * @description An hourly weather ECMWF Vert forecast object.
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class EcmwfForecastHourObj implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'ecmwfForecastHourObj';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'timestamp' => '\Swagger\Client\Model\Timestamp',
'timestamp_init' => '\Swagger\Client\Model\TimestampInit',
'cld_cvr' => '\Swagger\Client\Model\CldCvr',
'dew_pt' => '\Swagger\Client\Model\DewPt',
'feels_like' => '\Swagger\Client\Model\FeelsLike',
'heat_index' => '\Swagger\Client\Model\HeatIndex',
'msl_pres' => '\Swagger\Client\Model\MslPres',
'precip' => '\Swagger\Client\Model\Precip',
'precip_prob' => '\Swagger\Client\Model\PrecipProb',
'rad_solar' => '\Swagger\Client\Model\RadSolar',
'rad_solar_direct' => '\Swagger\Client\Model\RadSolarDirect',
'rad_solar_direct_p' => '\Swagger\Client\Model\RadSolarDirectP',
'rel_hum' => '\Swagger\Client\Model\RelHum',
'pres' => '\Swagger\Client\Model\Pres',
'snowfall' => '\Swagger\Client\Model\Snowfall',
'snowfall_prob' => '\Swagger\Client\Model\SnowfallProb',
'spc_hum' => '\Swagger\Client\Model\SpcHum',
'temp' => '\Swagger\Client\Model\Temp',
'wet_bulb' => '\Swagger\Client\Model\WetBulb',
'wind_chill' => '\Swagger\Client\Model\WindChill',
'wind_dir' => '\Swagger\Client\Model\WindDir',
'wind_spd' => '\Swagger\Client\Model\WindSpd'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'timestamp' => null,
'timestamp_init' => null,
'cld_cvr' => null,
'dew_pt' => null,
'feels_like' => null,
'heat_index' => null,
'msl_pres' => null,
'precip' => null,
'precip_prob' => null,
'rad_solar' => null,
'rad_solar_direct' => null,
'rad_solar_direct_p' => null,
'rel_hum' => null,
'pres' => null,
'snowfall' => null,
'snowfall_prob' => null,
'spc_hum' => null,
'temp' => null,
'wet_bulb' => null,
'wind_chill' => null,
'wind_dir' => null,
'wind_spd' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'timestamp' => 'timestamp',
'timestamp_init' => 'timestampInit',
'cld_cvr' => 'cldCvr',
'dew_pt' => 'dewPt',
'feels_like' => 'feelsLike',
'heat_index' => 'heatIndex',
'msl_pres' => 'mslPres',
'precip' => 'precip',
'precip_prob' => 'precipProb',
'rad_solar' => 'radSolar',
'rad_solar_direct' => 'radSolarDirect',
'rad_solar_direct_p' => 'radSolarDirectP',
'rel_hum' => 'relHum',
'pres' => 'pres',
'snowfall' => 'snowfall',
'snowfall_prob' => 'snowfallProb',
'spc_hum' => 'spcHum',
'temp' => 'temp',
'wet_bulb' => 'wetBulb',
'wind_chill' => 'windChill',
'wind_dir' => 'windDir',
'wind_spd' => 'windSpd'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'timestamp' => 'setTimestamp',
'timestamp_init' => 'setTimestampInit',
'cld_cvr' => 'setCldCvr',
'dew_pt' => 'setDewPt',
'feels_like' => 'setFeelsLike',
'heat_index' => 'setHeatIndex',
'msl_pres' => 'setMslPres',
'precip' => 'setPrecip',
'precip_prob' => 'setPrecipProb',
'rad_solar' => 'setRadSolar',
'rad_solar_direct' => 'setRadSolarDirect',
'rad_solar_direct_p' => 'setRadSolarDirectP',
'rel_hum' => 'setRelHum',
'pres' => 'setPres',
'snowfall' => 'setSnowfall',
'snowfall_prob' => 'setSnowfallProb',
'spc_hum' => 'setSpcHum',
'temp' => 'setTemp',
'wet_bulb' => 'setWetBulb',
'wind_chill' => 'setWindChill',
'wind_dir' => 'setWindDir',
'wind_spd' => 'setWindSpd'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'timestamp' => 'getTimestamp',
'timestamp_init' => 'getTimestampInit',
'cld_cvr' => 'getCldCvr',
'dew_pt' => 'getDewPt',
'feels_like' => 'getFeelsLike',
'heat_index' => 'getHeatIndex',
'msl_pres' => 'getMslPres',
'precip' => 'getPrecip',
'precip_prob' => 'getPrecipProb',
'rad_solar' => 'getRadSolar',
'rad_solar_direct' => 'getRadSolarDirect',
'rad_solar_direct_p' => 'getRadSolarDirectP',
'rel_hum' => 'getRelHum',
'pres' => 'getPres',
'snowfall' => 'getSnowfall',
'snowfall_prob' => 'getSnowfallProb',
'spc_hum' => 'getSpcHum',
'temp' => 'getTemp',
'wet_bulb' => 'getWetBulb',
'wind_chill' => 'getWindChill',
'wind_dir' => 'getWindDir',
'wind_spd' => 'getWindSpd'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['timestamp'] = isset($data['timestamp']) ? $data['timestamp'] : null;
        $this->container['timestamp_init'] = isset($data['timestamp_init']) ? $data['timestamp_init'] : null;
        $this->container['cld_cvr'] = isset($data['cld_cvr']) ? $data['cld_cvr'] : null;
        $this->container['dew_pt'] = isset($data['dew_pt']) ? $data['dew_pt'] : null;
        $this->container['feels_like'] = isset($data['feels_like']) ? $data['feels_like'] : null;
        $this->container['heat_index'] = isset($data['heat_index']) ? $data['heat_index'] : null;
        $this->container['msl_pres'] = isset($data['msl_pres']) ? $data['msl_pres'] : null;
        $this->container['precip'] = isset($data['precip']) ? $data['precip'] : null;
        $this->container['precip_prob'] = isset($data['precip_prob']) ? $data['precip_prob'] : null;
        $this->container['rad_solar'] = isset($data['rad_solar']) ? $data['rad_solar'] : null;
        $this->container['rad_solar_direct'] = isset($data['rad_solar_direct']) ? $data['rad_solar_direct'] : null;
        $this->container['rad_solar_direct_p'] = isset($data['rad_solar_direct_p']) ? $data['rad_solar_direct_p'] : null;
        $this->container['rel_hum'] = isset($data['rel_hum']) ? $data['rel_hum'] : null;
        $this->container['pres'] = isset($data['pres']) ? $data['pres'] : null;
        $this->container['snowfall'] = isset($data['snowfall']) ? $data['snowfall'] : null;
        $this->container['snowfall_prob'] = isset($data['snowfall_prob']) ? $data['snowfall_prob'] : null;
        $this->container['spc_hum'] = isset($data['spc_hum']) ? $data['spc_hum'] : null;
        $this->container['temp'] = isset($data['temp']) ? $data['temp'] : null;
        $this->container['wet_bulb'] = isset($data['wet_bulb']) ? $data['wet_bulb'] : null;
        $this->container['wind_chill'] = isset($data['wind_chill']) ? $data['wind_chill'] : null;
        $this->container['wind_dir'] = isset($data['wind_dir']) ? $data['wind_dir'] : null;
        $this->container['wind_spd'] = isset($data['wind_spd']) ? $data['wind_spd'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['timestamp'] === null) {
            $invalidProperties[] = "'timestamp' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets timestamp
     *
     * @return \Swagger\Client\Model\Timestamp
     */
    public function getTimestamp()
    {
        return $this->container['timestamp'];
    }

    /**
     * Sets timestamp
     *
     * @param \Swagger\Client\Model\Timestamp $timestamp timestamp
     *
     * @return $this
     */
    public function setTimestamp($timestamp)
    {
        $this->container['timestamp'] = $timestamp;

        return $this;
    }

    /**
     * Gets timestamp_init
     *
     * @return \Swagger\Client\Model\TimestampInit
     */
    public function getTimestampInit()
    {
        return $this->container['timestamp_init'];
    }

    /**
     * Sets timestamp_init
     *
     * @param \Swagger\Client\Model\TimestampInit $timestamp_init timestamp_init
     *
     * @return $this
     */
    public function setTimestampInit($timestamp_init)
    {
        $this->container['timestamp_init'] = $timestamp_init;

        return $this;
    }

    /**
     * Gets cld_cvr
     *
     * @return \Swagger\Client\Model\CldCvr
     */
    public function getCldCvr()
    {
        return $this->container['cld_cvr'];
    }

    /**
     * Sets cld_cvr
     *
     * @param \Swagger\Client\Model\CldCvr $cld_cvr cld_cvr
     *
     * @return $this
     */
    public function setCldCvr($cld_cvr)
    {
        $this->container['cld_cvr'] = $cld_cvr;

        return $this;
    }

    /**
     * Gets dew_pt
     *
     * @return \Swagger\Client\Model\DewPt
     */
    public function getDewPt()
    {
        return $this->container['dew_pt'];
    }

    /**
     * Sets dew_pt
     *
     * @param \Swagger\Client\Model\DewPt $dew_pt dew_pt
     *
     * @return $this
     */
    public function setDewPt($dew_pt)
    {
        $this->container['dew_pt'] = $dew_pt;

        return $this;
    }

    /**
     * Gets feels_like
     *
     * @return \Swagger\Client\Model\FeelsLike
     */
    public function getFeelsLike()
    {
        return $this->container['feels_like'];
    }

    /**
     * Sets feels_like
     *
     * @param \Swagger\Client\Model\FeelsLike $feels_like feels_like
     *
     * @return $this
     */
    public function setFeelsLike($feels_like)
    {
        $this->container['feels_like'] = $feels_like;

        return $this;
    }

    /**
     * Gets heat_index
     *
     * @return \Swagger\Client\Model\HeatIndex
     */
    public function getHeatIndex()
    {
        return $this->container['heat_index'];
    }

    /**
     * Sets heat_index
     *
     * @param \Swagger\Client\Model\HeatIndex $heat_index heat_index
     *
     * @return $this
     */
    public function setHeatIndex($heat_index)
    {
        $this->container['heat_index'] = $heat_index;

        return $this;
    }

    /**
     * Gets msl_pres
     *
     * @return \Swagger\Client\Model\MslPres
     */
    public function getMslPres()
    {
        return $this->container['msl_pres'];
    }

    /**
     * Sets msl_pres
     *
     * @param \Swagger\Client\Model\MslPres $msl_pres msl_pres
     *
     * @return $this
     */
    public function setMslPres($msl_pres)
    {
        $this->container['msl_pres'] = $msl_pres;

        return $this;
    }

    /**
     * Gets precip
     *
     * @return \Swagger\Client\Model\Precip
     */
    public function getPrecip()
    {
        return $this->container['precip'];
    }

    /**
     * Sets precip
     *
     * @param \Swagger\Client\Model\Precip $precip precip
     *
     * @return $this
     */
    public function setPrecip($precip)
    {
        $this->container['precip'] = $precip;

        return $this;
    }

    /**
     * Gets precip_prob
     *
     * @return \Swagger\Client\Model\PrecipProb
     */
    public function getPrecipProb()
    {
        return $this->container['precip_prob'];
    }

    /**
     * Sets precip_prob
     *
     * @param \Swagger\Client\Model\PrecipProb $precip_prob precip_prob
     *
     * @return $this
     */
    public function setPrecipProb($precip_prob)
    {
        $this->container['precip_prob'] = $precip_prob;

        return $this;
    }

    /**
     * Gets rad_solar
     *
     * @return \Swagger\Client\Model\RadSolar
     */
    public function getRadSolar()
    {
        return $this->container['rad_solar'];
    }

    /**
     * Sets rad_solar
     *
     * @param \Swagger\Client\Model\RadSolar $rad_solar rad_solar
     *
     * @return $this
     */
    public function setRadSolar($rad_solar)
    {
        $this->container['rad_solar'] = $rad_solar;

        return $this;
    }

    /**
     * Gets rad_solar_direct
     *
     * @return \Swagger\Client\Model\RadSolarDirect
     */
    public function getRadSolarDirect()
    {
        return $this->container['rad_solar_direct'];
    }

    /**
     * Sets rad_solar_direct
     *
     * @param \Swagger\Client\Model\RadSolarDirect $rad_solar_direct rad_solar_direct
     *
     * @return $this
     */
    public function setRadSolarDirect($rad_solar_direct)
    {
        $this->container['rad_solar_direct'] = $rad_solar_direct;

        return $this;
    }

    /**
     * Gets rad_solar_direct_p
     *
     * @return \Swagger\Client\Model\RadSolarDirectP
     */
    public function getRadSolarDirectP()
    {
        return $this->container['rad_solar_direct_p'];
    }

    /**
     * Sets rad_solar_direct_p
     *
     * @param \Swagger\Client\Model\RadSolarDirectP $rad_solar_direct_p rad_solar_direct_p
     *
     * @return $this
     */
    public function setRadSolarDirectP($rad_solar_direct_p)
    {
        $this->container['rad_solar_direct_p'] = $rad_solar_direct_p;

        return $this;
    }

    /**
     * Gets rel_hum
     *
     * @return \Swagger\Client\Model\RelHum
     */
    public function getRelHum()
    {
        return $this->container['rel_hum'];
    }

    /**
     * Sets rel_hum
     *
     * @param \Swagger\Client\Model\RelHum $rel_hum rel_hum
     *
     * @return $this
     */
    public function setRelHum($rel_hum)
    {
        $this->container['rel_hum'] = $rel_hum;

        return $this;
    }

    /**
     * Gets pres
     *
     * @return \Swagger\Client\Model\Pres
     */
    public function getPres()
    {
        return $this->container['pres'];
    }

    /**
     * Sets pres
     *
     * @param \Swagger\Client\Model\Pres $pres pres
     *
     * @return $this
     */
    public function setPres($pres)
    {
        $this->container['pres'] = $pres;

        return $this;
    }

    /**
     * Gets snowfall
     *
     * @return \Swagger\Client\Model\Snowfall
     */
    public function getSnowfall()
    {
        return $this->container['snowfall'];
    }

    /**
     * Sets snowfall
     *
     * @param \Swagger\Client\Model\Snowfall $snowfall snowfall
     *
     * @return $this
     */
    public function setSnowfall($snowfall)
    {
        $this->container['snowfall'] = $snowfall;

        return $this;
    }

    /**
     * Gets snowfall_prob
     *
     * @return \Swagger\Client\Model\SnowfallProb
     */
    public function getSnowfallProb()
    {
        return $this->container['snowfall_prob'];
    }

    /**
     * Sets snowfall_prob
     *
     * @param \Swagger\Client\Model\SnowfallProb $snowfall_prob snowfall_prob
     *
     * @return $this
     */
    public function setSnowfallProb($snowfall_prob)
    {
        $this->container['snowfall_prob'] = $snowfall_prob;

        return $this;
    }

    /**
     * Gets spc_hum
     *
     * @return \Swagger\Client\Model\SpcHum
     */
    public function getSpcHum()
    {
        return $this->container['spc_hum'];
    }

    /**
     * Sets spc_hum
     *
     * @param \Swagger\Client\Model\SpcHum $spc_hum spc_hum
     *
     * @return $this
     */
    public function setSpcHum($spc_hum)
    {
        $this->container['spc_hum'] = $spc_hum;

        return $this;
    }

    /**
     * Gets temp
     *
     * @return \Swagger\Client\Model\Temp
     */
    public function getTemp()
    {
        return $this->container['temp'];
    }

    /**
     * Sets temp
     *
     * @param \Swagger\Client\Model\Temp $temp temp
     *
     * @return $this
     */
    public function setTemp($temp)
    {
        $this->container['temp'] = $temp;

        return $this;
    }

    /**
     * Gets wet_bulb
     *
     * @return \Swagger\Client\Model\WetBulb
     */
    public function getWetBulb()
    {
        return $this->container['wet_bulb'];
    }

    /**
     * Sets wet_bulb
     *
     * @param \Swagger\Client\Model\WetBulb $wet_bulb wet_bulb
     *
     * @return $this
     */
    public function setWetBulb($wet_bulb)
    {
        $this->container['wet_bulb'] = $wet_bulb;

        return $this;
    }

    /**
     * Gets wind_chill
     *
     * @return \Swagger\Client\Model\WindChill
     */
    public function getWindChill()
    {
        return $this->container['wind_chill'];
    }

    /**
     * Sets wind_chill
     *
     * @param \Swagger\Client\Model\WindChill $wind_chill wind_chill
     *
     * @return $this
     */
    public function setWindChill($wind_chill)
    {
        $this->container['wind_chill'] = $wind_chill;

        return $this;
    }

    /**
     * Gets wind_dir
     *
     * @return \Swagger\Client\Model\WindDir
     */
    public function getWindDir()
    {
        return $this->container['wind_dir'];
    }

    /**
     * Sets wind_dir
     *
     * @param \Swagger\Client\Model\WindDir $wind_dir wind_dir
     *
     * @return $this
     */
    public function setWindDir($wind_dir)
    {
        $this->container['wind_dir'] = $wind_dir;

        return $this;
    }

    /**
     * Gets wind_spd
     *
     * @return \Swagger\Client\Model\WindSpd
     */
    public function getWindSpd()
    {
        return $this->container['wind_spd'];
    }

    /**
     * Sets wind_spd
     *
     * @param \Swagger\Client\Model\WindSpd $wind_spd wind_spd
     *
     * @return $this
     */
    public function setWindSpd($wind_spd)
    {
        $this->container['wind_spd'] = $wind_spd;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
